//
//  DetailViewController.m
//  WHM08_iOS
//
//  Created by 富樫 豊彦 on 2014/01/13.
//  Copyright (c) 2014年 富樫 豊彦. All rights reserved.
//

#import "DetailViewController.h"

@interface DetailViewController ()
- (void)configureView;
@end

@implementation DetailViewController

#pragma mark - Managing the detail item

- (void)setDetailItem:(id)newDetailItem
{
    if (_detailItem != newDetailItem) {
        _detailItem = newDetailItem;
        
        // Update the view.
        [self configureView];
    }
}

- (void)configureView
{
    // Update the user interface for the detail item.

//    if (self.detailItem) {
//        self.detailDescriptionLabel.text = [[self.detailItem valueForKey:@"timeStamp"] description];
//    }
    
    if (self.detailItem) {
        long    chNumber  = [[self.detailItem valueForKey:@"chNumber"] integerValue];
        long    power     = [[self.detailItem valueForKey:@"power"] integerValue];
        float   current   = [[self.detailItem valueForKey:@"current"] floatValue];
        long    voltage   = [[self.detailItem valueForKey:@"voltage"] integerValue];
        long    frequency = [[self.detailItem valueForKey:@"frequency"] integerValue];
        float   energy    = [[self.detailItem valueForKey:@"energy"] floatValue];
        
        self.chName.text        = [self.detailItem valueForKey:@"chName"];
        self.chNumber.text      = [[NSString alloc] initWithFormat:@"%ld",chNumber];
        self.ePower.text        = [[NSString alloc] initWithFormat:@"%ld",power];
        self.eCurrent.text      = [[NSString alloc] initWithFormat:@"%.2f",current];
        self.eVoltage.text      = [[NSString alloc] initWithFormat:@"%ld",voltage];
        self.eFrequency.text    = [[NSString alloc] initWithFormat:@"%ld",frequency];
        self.eEnergy.text       = [[NSString alloc] initWithFormat:@"%.2f",energy];
        self.powerFactor.text   = [[NSString alloc] initWithFormat:@"%d",(int)(power / (current * voltage) * 100.0)];
        self.apparentPower.text = [[NSString alloc] initWithFormat:@"%d",(int)(current * voltage)];
    }
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    [self configureView];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
